//
// Yet Another Ping Of Death Bot Configuration Tool
// Copyright (c) 2005, by Dmitry Zhukov. All Rights Reserved.
//
// P.S.: I HATE BORLANDC C++ BUILDER IDE! :)
//

#ifndef yapbconfigH
#define yapbconfigH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>

#include <stdio.h>
#include <string.h>
#include <values.h>

#include "genclass.h"
#include "confparse.h"
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <ComCtrls.hpp>
#include <jpeg.hpp>


inline char *qitoa (int iInput)
{
   static char sz[32];
   sprintf (sz, "%i", iInput);

   return &sz[0];
}

inline char *qftoa (float fInput)
{
   static char sz[32];
   sprintf (sz, "%f", fInput);

   return &sz[0];
}

inline char *btoa (bool bInput)
{
   return bInput ? "1" : "0";
}

inline char *vaf (char *fmt, ...)
{
   va_list ap;
   static char buffer[256];

   va_start (ap, fmt);
   vsprintf (buffer, fmt, ap);
   va_end (ap);

   return (&buffer[0]);
}

#define CONFIG_QUOTA "yapb_quota"
#define CONFIG_AUTOVACATE "yapb_autovacate"
#define CONFIG_MINSKILL "yapb_minskill"
#define CONFIG_MAXSKILL "yapb_maxskill"
#define CONFIG_FOLLOWUSER "yapb_followuser"
#define CONFIG_TIMESOUND "yapb_timersound"
#define CONFIG_TIMEPICKUP "yapb_timerpickup"
#define CONFIG_TIMEGRENADE "yapb_timergrenade"
#define CONFIG_USEEXP "yapb_useexp"
#define CONFIG_SAVEEXP "yapb_autosaveexp"
#define CONFIG_USECHAT "yapb_botchat"
#define CONFIG_USERADIO "yapb_botuseradio"
#define CONFIG_JASONMODE "yapb_jasonmode"
#define CONFIG_DETAILNAMES "yapb_detailnames"
#define CONFIG_INSTANT_TURNS "yapb_inhumanturns"
#define CONFIG_THRUWALLS "yapb_shootthruwalls"
#define CONFIG_VOTES "yapb_votekick"
#define CONFIG_SPRAY "yapb_botspray"
#define CONFIG_BUYING "yapb_botbuy"
#define CONFIG_WPTFOLDER "yapb_wptfolder"

//---------------------------------------------------------------------------
class TMain : public TForm
{
__published:	// IDE-managed Components
   TGroupBox *TimerGroup;
   TEdit *SoundTimer;
   TLabel *SoundInfo;
   TLabel *GrenInfo;
   TEdit *GrenTimer;
   TEdit *PickTimer;
   TLabel *PickInfo;
   TGroupBox *MainGroup;
   TCheckBox *BotVoting;
   TCheckBox *BotSpray;
   TCheckBox *BotBuy;
   TCheckBox *BotThruWall;
   TCheckBox *BotInstant;
   TCheckBox *BotDetailNames;
   TCheckBox *BotJason;
   TCheckBox *BotRadio;
   TCheckBox *BotExpSave;
   TCheckBox *BotUseExp;
   TCheckBox *BotChat;
   TCheckBox *BotAutovacate;
   TGroupBox *OtherGroup;
   TScrollBar *MaxSkill;
   TLabel *MaxInfo;
   TScrollBar *MinSkill;
   TLabel *MinInfo;
   TLabel *MaxFollowInfo;
   TScrollBar *MaxFollow;
   TLabel *Quota;
   TScrollBar *QuotaChange;
   TEdit *MaxSkillShow;
   TEdit *MinSkillShow;
   TEdit *FollowShow;
   TEdit *QuotaShow;
   TMemo *Info;
   TLabel *Information;
   TButton *Reload;
   TButton *Save;
   TLabeledEdit *WptFldr;
   TShape *Shape1;
   TButton *SaveClean;
   TSaveDialog *SaveDialog;
   TButton *SaveAndExit;
   TButton *JustExit;
   TListBox *Lang;
   TLabel *LangInfo;
   TImage *TheIco;
   TLabel *Yapb;
        TPageControl *Pages;
        TTabSheet *General;
        TTabSheet *Skill;
   TPanel *MainPanel;
   TGroupBox *ReactionGroup;
   TScrollBar *MaxReactScroll;
   TScrollBar *MinReactScroll;
   TEdit *MaxReactShow;
   TEdit *MinReactShow;
   TGroupBox *AimOffsGroup;
   TScrollBar *AimXScroll;
   TScrollBar *AimYScroll;
   TEdit *AimXShow;
   TEdit *AimYShow;
   TEdit *AimZShow;
   TScrollBar *AimZScroll;
   TGroupBox *Probs;
   TScrollBar *HeadAimScroll;
   TEdit *HeadAimShow;
   TLabel *Infos;
   TEdit *SeenShow;
   TEdit *HeardShow;
   TScrollBar *HeardScroll;
   TScrollBar *SeenScroll;
   TLabel *BlaBlaBla;
   TLabel *MaxReact;
   TLabel *MinReact;
   TLabel *HeadAim;
   TLabel *Heard;
   TLabel *Seeing;
   TLabel *AimOffsX;
   TLabel *AimOffsY;
   TLabel *AimOffsZ;
   TComboBox *SkillSelect;
   TImage *Image;
   TButton *Apply;
   void __fastcall FormCreate(TObject *Sender);
   void __fastcall MaxSkillChange(TObject *Sender);
   void __fastcall MinSkillChange(TObject *Sender);
   void __fastcall MaxFollowChange(TObject *Sender);
   void __fastcall QuotaChangeChange(TObject *Sender);
   void __fastcall BotVotingMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall BotSprayMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall BotBuyMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall BotThruWallMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall BotInstantMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall BotDetailNamesMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
   void __fastcall BotJasonMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall BotRadioMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall BotExpSaveMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall BotChatMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall BotAutovacateMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
   void __fastcall BotUseExpMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall SoundInfoMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall GrenInfoMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall PickInfoMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall MaxInfoMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall MinInfoMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall MaxFollowInfoMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
   void __fastcall QuotaMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall ReloadClick(TObject *Sender);
   void __fastcall SaveClick(TObject *Sender);
   void __fastcall WptFldrMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall SaveCleanClick(TObject *Sender);
   void __fastcall SaveAndExitClick(TObject *Sender);
   void __fastcall JustExitClick(TObject *Sender);
   void __fastcall SaveCleanMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall ReloadMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall SaveMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
   void __fastcall SaveAndExitMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall JustExitMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall LangInfoMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall LangDblClick(TObject *Sender);
   void __fastcall TheIcoClick(TObject *Sender);
   void __fastcall YapbClick(TObject *Sender);
   void __fastcall TheIcoMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall YapbMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
   void __fastcall MaxReactScrollChange(TObject *Sender);
   void __fastcall MinReactScrollChange(TObject *Sender);
   void __fastcall AimXScrollChange(TObject *Sender);
   void __fastcall AimYScrollChange(TObject *Sender);
   void __fastcall AimZScrollChange(TObject *Sender);
   void __fastcall HeadAimScrollChange(TObject *Sender);
   void __fastcall HeardScrollChange(TObject *Sender);
   void __fastcall SeenScrollChange(TObject *Sender);
   void __fastcall AimOffsGroupMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
   void __fastcall ReactionGroupMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
   void __fastcall HeadAimMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall HeardMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall SeeingMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
   void __fastcall SkillSelectChange(TObject *Sender);
   void __fastcall ApplyClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
   __fastcall TMain(TComponent* Owner);
   void CheckBox (string sConfigVar, TCheckBox *pHolder);
   vector <string> GetData (void);
};
//---------------------------------------------------------------------------
extern PACKAGE TMain *Main;
//---------------------------------------------------------------------------
#endif
