//
// Yet Another Ping Of Death Bot Configuration Tool
// Copyright (c) 2005, by Dmitry Zhukov. All Rights Reserved.
//
// P.S.: I HATE BORLANDC C++ BUILDER IDE! :)
//

#include <vcl.h>
#pragma hdrstop

#include "yapbconfig.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TMain *Main;
CConfig g_kConfig ("podbot.cfg");
CSkillConfig g_kSkill;

//---------------------------------------------------------------------------
__fastcall TMain::TMain(TComponent* Owner)
   : TForm(Owner)
{
   HeadAimShow->Text = "0";
   HeardShow->Text = "0";
   SeenShow->Text = "0";
   MaxReactShow->Text = "0.0";
   MinReactShow->Text = "0.0";
   AimXShow->Text = "0.0";
   AimYShow->Text = "0.0";
   AimZShow->Text = "0.0";
}
//---------------------------------------------------------------------------


void __fastcall TMain::FormCreate(TObject *Sender)
{
   GrenTimer->Text = g_kConfig.GetValue <float> (CONFIG_TIMEGRENADE);
   PickTimer->Text = g_kConfig.GetValue <float> (CONFIG_TIMEPICKUP);
   SoundTimer->Text = g_kConfig.GetValue <float> (CONFIG_TIMESOUND);
   WptFldr->Text = g_kConfig.GetString (CONFIG_WPTFOLDER)->GetString ();
   
   MaxSkill->Position = g_kConfig.GetValue <int> (CONFIG_MAXSKILL);
   MinSkill->Position = g_kConfig.GetValue <int> (CONFIG_MINSKILL);
   MaxFollow->Position = g_kConfig.GetValue <int> (CONFIG_FOLLOWUSER);
   QuotaChange->Position = g_kConfig.GetValue <int> (CONFIG_QUOTA) == 666 ? 0 : g_kConfig.GetValue <int> (CONFIG_QUOTA);
   
   CheckBox (CONFIG_VOTES, BotVoting);
   CheckBox (CONFIG_SPRAY, BotSpray);
   CheckBox (CONFIG_BUYING, BotBuy);
   CheckBox (CONFIG_THRUWALLS, BotThruWall);
   CheckBox (CONFIG_INSTANT_TURNS, BotInstant);
   CheckBox (CONFIG_DETAILNAMES, BotDetailNames);
   CheckBox (CONFIG_JASONMODE, BotJason);
   CheckBox (CONFIG_USERADIO, BotRadio);
   CheckBox (CONFIG_SAVEEXP, BotExpSave);
   CheckBox (CONFIG_USEEXP, BotUseExp);
   CheckBox (CONFIG_USECHAT, BotChat);
   CheckBox (CONFIG_AUTOVACATE, BotAutovacate);

   Lang->Items->Clear ();
   Apply->Enabled = FALSE;


   WIN32_FIND_DATA kFd;
   HANDLE hFind = FindFirstFile ("language/*.txt", &kFd);

   do
   {
      if (!strstr (strlwr (kFd.cFileName), "readme.txt"))
         Lang->Items->Add (kFd.cFileName);
   }
   while (FindNextFile (hFind, &kFd));

   CloseHandle (hFind);
}
//---------------------------------------------------------------------------
void TMain::CheckBox (string sConfigVar, TCheckBox *pHolder)
{
   if (pHolder == NULL)
      return;

   int iRetVal = g_kConfig.IsOn (sConfigVar);

   switch (iRetVal)
   {
   case 0: // enabled
      pHolder->Checked = FALSE;
      break;

   case 1: // disabled
      pHolder->Checked = TRUE;
      break;

   case 2: // will be appended to config file(TODO)
      pHolder->Enabled = FALSE;
      break;
   }
}
void __fastcall TMain::MaxSkillChange(TObject *Sender)
{
   MaxSkillShow->Text =  qitoa (MaxSkill->Position);
}
//---------------------------------------------------------------------------

void __fastcall TMain::MinSkillChange(TObject *Sender)
{
   MinSkillShow->Text = qitoa (MinSkill->Position);   
}
//---------------------------------------------------------------------------

void __fastcall TMain::MaxFollowChange(TObject *Sender)
{
   FollowShow->Text = qitoa (MaxFollow->Position);
}
//---------------------------------------------------------------------------

void __fastcall TMain::QuotaChangeChange(TObject *Sender)
{
   QuotaShow->Text = qitoa (QuotaChange->Position);
}
//---------------------------------------------------------------------------

void __fastcall TMain::BotVotingMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "This option turns on/off Bots voting against. Team Killers (Humans only).";

}
//---------------------------------------------------------------------------

void __fastcall TMain::BotSprayMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "Set this to off to disallow Bot Logo Spraying.";
}
//---------------------------------------------------------------------------

void __fastcall TMain::BotBuyMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
   Info->Text = "Set this to off to disallow bot Buy Weapons.";
}
//---------------------------------------------------------------------------

void __fastcall TMain::BotThruWallMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "This Variable specifies if Bots are allowed to shoot through Walls if they saw an enemy or if they heard someone on the other Side of a Wall (additional Settings are specified in \"botskill.cfg\").";
}
//---------------------------------------------------------------------------

void __fastcall TMain::BotInstantMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "Set this option to on if you want the old combat behaviour of instantly turning around to the enemy.";
}
//---------------------------------------------------------------------------

void __fastcall TMain::BotDetailNamesMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "Set the below option to off to turn off the Skilldisplay and the [POD] before the name.";
}
//---------------------------------------------------------------------------

void __fastcall TMain::BotJasonMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "Turns on/off Jason Mode! Meaning Bots don't buy weapons and only use the knife for combat! Use this for much fun with e.a. cs_estate or cs_office.";
}
//---------------------------------------------------------------------------

void __fastcall TMain::BotRadioMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "Turns on/off bots' using radio communications.";   
}
//---------------------------------------------------------------------------

void __fastcall TMain::BotExpSaveMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "Turn this on to save the .pxp files automatically.";
}
//---------------------------------------------------------------------------

void __fastcall TMain::BotChatMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
   Info->Text = "Turns on/off Botchatting. Bots chat if they killed someone, if the Bomb was planted or if they are dead and bored.";
}
//---------------------------------------------------------------------------


void __fastcall TMain::BotAutovacateMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "Turns on/off auto vacate.";
}
//---------------------------------------------------------------------------

void __fastcall TMain::BotUseExpMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "Turn this on/off to allow the Bots collecting experience about the map they're playing (turning this off also gives back some CPU performance).";
}
//---------------------------------------------------------------------------

void __fastcall TMain::SoundInfoMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "These Settings below specify the Rate (in Seconds) of updating some of the Bot Checks. If you've got a slow computer you could try changing these to higher values to get some performance back. NOTE: This seriously affects the Bots Perception. If you have a fast computer you might try lowering them to get better playing results";
}
//---------------------------------------------------------------------------

void __fastcall TMain::GrenInfoMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   SoundInfoMouseMove (Sender, Shift, X, Y);
}
//---------------------------------------------------------------------------

void __fastcall TMain::PickInfoMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   SoundInfoMouseMove (Sender, Shift, X, Y);
}
//---------------------------------------------------------------------------

void __fastcall TMain::MaxInfoMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
   Info->Text = "That variable used to limit Bots to the specified skill.";
}

void __fastcall TMain::MinInfoMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
   Info->Text = "That variable used to add Bots that have at least a Skill of 60.";   
}
//---------------------------------------------------------------------------

void __fastcall TMain::MaxFollowInfoMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "This value sets the maximum number of Bots to follow a User";   
}
//---------------------------------------------------------------------------

void __fastcall TMain::QuotaMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
   Info->Text = "This variable used to support a number of bots running on the server.  Bots will be added to the server until the total number of players (bots and humans) reaches the yapb_quota value.";
}
//---------------------------------------------------------------------------

void __fastcall TMain::ReloadClick(TObject *Sender)
{
   g_kConfig = CConfig ("podbot.cfg");
   FormCreate (Sender);
}
//---------------------------------------------------------------------------

vector <string> TMain::GetData (void)
{
   string rgsTimers[3];
   rgsTimers[0] = SoundTimer->Text.c_str();
   rgsTimers[1] = GrenTimer->Text.c_str();
   rgsTimers[2] = PickTimer->Text.c_str();

   rgsTimers[0].Replace (',', '.');
   rgsTimers[1].Replace (',', '.');
   rgsTimers[2].Replace (',', '.');

   g_kConfig.SetString (CONFIG_QUOTA, MaxSkillShow->Text.c_str());
   g_kConfig.SetString (CONFIG_AUTOVACATE, btoa (BotAutovacate->Checked));
   g_kConfig.SetString (CONFIG_MINSKILL, MinSkillShow->Text.c_str());
   g_kConfig.SetString (CONFIG_MAXSKILL, MaxSkillShow->Text.c_str());
   g_kConfig.SetString (CONFIG_FOLLOWUSER, FollowShow->Text.c_str());
   g_kConfig.SetString (CONFIG_WPTFOLDER, WptFldr->Text.c_str ());
   g_kConfig.SetString (CONFIG_TIMESOUND, rgsTimers[0]);
   g_kConfig.SetString (CONFIG_TIMEPICKUP, rgsTimers[1]);
   g_kConfig.SetString (CONFIG_TIMEGRENADE, rgsTimers[2]);
   g_kConfig.SetString (CONFIG_USEEXP, btoa (BotUseExp->Checked));
   g_kConfig.SetString (CONFIG_SAVEEXP, btoa (BotExpSave->Checked));
   g_kConfig.SetString (CONFIG_USECHAT, btoa (BotChat->Checked));
   g_kConfig.SetString (CONFIG_USERADIO, btoa (BotRadio->Checked));
   g_kConfig.SetString (CONFIG_JASONMODE, btoa (BotJason->Checked));
   g_kConfig.SetString (CONFIG_DETAILNAMES, btoa (BotDetailNames->Checked));
   g_kConfig.SetString (CONFIG_INSTANT_TURNS, btoa (BotInstant->Checked));
   g_kConfig.SetString (CONFIG_THRUWALLS, btoa (BotThruWall->Checked));
   g_kConfig.SetString (CONFIG_VOTES, btoa (BotVoting->Checked));
   g_kConfig.SetString (CONFIG_SPRAY, btoa (BotSpray->Checked));
   g_kConfig.SetString (CONFIG_BUYING, btoa (BotBuy->Checked));

   return g_kConfig.GetData ();
}
void __fastcall TMain::SaveClick(TObject *Sender)
{
   GetData ();
   g_kConfig.WriteOutput ();
}
//---------------------------------------------------------------------------

void __fastcall TMain::WptFldrMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
   Info->Text = "This sets the Waypoint Folder (in the yapb directory) for loading/saving waypoints. Don't use a trailing backslash or spaces.";
}
//---------------------------------------------------------------------------

void __fastcall TMain::SaveCleanClick(TObject *Sender)
{
   char szOldDir[256];
   GetCurrentDirectory (255, szOldDir);

   if (SaveDialog->Execute ())
   {
      GetData ();
      g_kConfig.WriteOutput (TRUE, SaveDialog->FileName.c_str());

      SetCurrentDirectory (szOldDir);
   }
}
//---------------------------------------------------------------------------

void __fastcall TMain::SaveAndExitClick(TObject *Sender)
{
   SaveClick (Sender);
   g_kSkill.WriteConfig ();

   ExitProcess (TRUE);
}
//---------------------------------------------------------------------------

void __fastcall TMain::JustExitClick(TObject *Sender)
{
   ExitProcess (TRUE);   
}
//---------------------------------------------------------------------------

void __fastcall TMain::SaveCleanMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "Save clean config file withour any comments & sharp (or blank)lines!";  
}
//---------------------------------------------------------------------------

void __fastcall TMain::ReloadMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
   Info->Text = "Loading podbot.cfg, once again, and set all values in program to defaults...";
}
//---------------------------------------------------------------------------

void __fastcall TMain::SaveMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
   Info->Text = "Save podbot.cfg, you will not exit program after pressing this button!";
}
//---------------------------------------------------------------------------

void __fastcall TMain::SaveAndExitMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "Save all data to podbot.cfg & BotSkill.cfg, and quit program after that!";
}
//---------------------------------------------------------------------------

void __fastcall TMain::JustExitMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "Exit program without any changes...";
}
//---------------------------------------------------------------------------

void __fastcall TMain::LangInfoMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "Here you can select language, for menus & bot messages.";   
}
//---------------------------------------------------------------------------

void __fastcall TMain::LangDblClick(TObject *Sender)
{
   char szFile[64];
   sprintf (szFile, "language/%s", Lang->Items->operator [] (Lang->ItemIndex).c_str ());

   CopyFile (szFile, "lang.txt", FALSE);

   ShowMessage ("Language " + Lang->Items->operator [] (Lang->ItemIndex) + " is set to Default bot language!");
}
//---------------------------------------------------------------------------

void __fastcall TMain::TheIcoClick(TObject *Sender)
{
   ShellExecute (NULL, "open", "http://yapb.bots-united.com", NULL, NULL, SW_SHOW);   
}
//---------------------------------------------------------------------------

void __fastcall TMain::YapbClick(TObject *Sender)
{
   TheIcoClick (Sender);   
}
//---------------------------------------------------------------------------

void __fastcall TMain::TheIcoMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
   Info->Text = "Visit Official YaPB Home!";   
}
//---------------------------------------------------------------------------

void __fastcall TMain::YapbMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
   TheIcoMouseMove (Sender, Shift, X, Y);
}
//---------------------------------------------------------------------------


/////////////////////////////////////////////////////////////////////////////
// SKILL CONFIGURATION PAGE EVENT HANDLERS //////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void __fastcall TMain::MaxReactScrollChange(TObject *Sender)
{
   // this fucking borland scrollbar component, don't understand floats :(
   int iVal = MaxReactScroll->Position;
   char *szCalc = vaf ("%d.%d", iVal >= 100 ? 1 : 0, iVal >= 100 ? 0 : iVal / 10);

   MaxReactShow->Text = szCalc;
   g_kSkill.Set (SkillSelect->ItemIndex)->fMaxDelay = atof (szCalc);
}
//---------------------------------------------------------------------------

void __fastcall TMain::MinReactScrollChange(TObject *Sender)
{
   // this fucking borland scrollbar component, don't understand floats :(
   int iVal = MinReactScroll->Position;
   char *szCalc = vaf ("%d.%d", iVal >= 100 ? 1 : 0, iVal >= 100 ? 0 : iVal / 10);

   MinReactShow->Text = szCalc;
   g_kSkill.Set (SkillSelect->ItemIndex)->fMinDelay = atof (szCalc);
}
//---------------------------------------------------------------------------

void __fastcall TMain::AimXScrollChange(TObject *Sender)
{
   AimXShow->Text = qitoa (AimXScroll->Position);
   g_kSkill.Set (SkillSelect->ItemIndex)->fAimOffsX = atoi (AimXShow->Text.c_str ());
}
//---------------------------------------------------------------------------

void __fastcall TMain::AimYScrollChange(TObject *Sender)
{
   AimYShow->Text = qitoa (AimYScroll->Position);
   g_kSkill.Set (SkillSelect->ItemIndex)->fAimOffsY = atoi (AimYShow->Text.c_str ());
}
//---------------------------------------------------------------------------

void __fastcall TMain::AimZScrollChange(TObject *Sender)
{
   AimZShow->Text = qitoa (AimZScroll->Position);
   g_kSkill.Set (SkillSelect->ItemIndex)->fAimOffsZ = atoi (AimZShow->Text.c_str ());
}
//---------------------------------------------------------------------------

void __fastcall TMain::HeadAimScrollChange(TObject *Sender)
{
   HeadAimShow->Text = qitoa (HeadAimScroll->Position);
   g_kSkill.Set (SkillSelect->ItemIndex)->fHeadshot = atoi (HeadAimShow->Text.c_str ());
}
//---------------------------------------------------------------------------

void __fastcall TMain::HeardScrollChange(TObject *Sender)
{
   HeardShow->Text = qitoa (HeardScroll->Position);
   g_kSkill.Set (SkillSelect->ItemIndex)->fHearProb = atoi (HeardShow->Text.c_str ());
}
//---------------------------------------------------------------------------

void __fastcall TMain::SeenScrollChange(TObject *Sender)
{
   SeenShow->Text = qitoa (SeenScroll->Position);
   g_kSkill.Set (SkillSelect->ItemIndex)->fSeenProb = atoi (SeenShow->Text.c_str ());
}
//---------------------------------------------------------------------------


void __fastcall TMain::AimOffsGroupMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "This values are the offsets for aiming (note that HL uses the lefthanded coordinate system where Z is the Up Direction).";
}
//---------------------------------------------------------------------------

void __fastcall TMain::ReactionGroupMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   Info->Text = "Specifies the Reaction Time in Seconds.";   
}
//---------------------------------------------------------------------------

void __fastcall TMain::HeadAimMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
   Info->Text = "Specifies (in percent) the probability of aiming at the Head. This doesn't mean he actually fires at your head but he is allowed to do so.";
}
//---------------------------------------------------------------------------

void __fastcall TMain::HeardMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
   Info->Text = "Specifies (in percent) the probability of shooting through Obstacles if the Bot has heard someone, has a weapon to do so and has this enemy in his viewing cone.";
}
//---------------------------------------------------------------------------

void __fastcall TMain::SeeingMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
   Info->Text = "Specifies (in percent) the probability of shooting through Obstacles if the Bot has seen this enemy before, has a weapon to do so and this enemy is still in his viewing cone.";
}
//---------------------------------------------------------------------------

void __fastcall TMain::SkillSelectChange(TObject *Sender)
{
   g_kSkill.SetIDE (SkillSelect->ItemIndex);
   Apply->Enabled = TRUE;
}
//---------------------------------------------------------------------------

void __fastcall TMain::ApplyClick(TObject *Sender)
{
   g_kSkill.WriteConfig ();
   ShowMessage ("Changes has been applied to BotSkill.cfg");
}
//---------------------------------------------------------------------------

